//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@BlbgGtFNg@v0.3
//@@@by iuser/5145841j
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@[U[p[^

#define SHADOW_WIDTH 0.1
#define TONE_CURVE 1.25


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@`

//@_O^[Qbg̃NAl
float4 ClearColor = {1,1,1,1};
float ClearDepth  = 1.0;

//@|XgGtFNg錾
float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

//@IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = {1.0,1.0};
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = NONE;
	MagFilter = NONE;
	MipFilter = NONE;
	AddressU  = CLAMP;
	AddressV = CLAMP;
};

// [xobt@
texture DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
>;

//@XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

static float AspectRatio = (ViewportSize.x / ViewportSize.y);

//@ANZTݒl擾
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha = MaterialDiffuse.a;

float scaling0 : CONTROLOBJECT < string name = "(self)"; >;
static float scaling = scaling0 * 0.1;

float3 ObjXYZ : CONTROLOBJECT < string name = "(self)"; string item = "XYZ"; >;
float3 ObjRxyz : CONTROLOBJECT < string name = "(self)"; string item = "Rxyz"; >;


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@_VF[_
struct VS_OUTPUT {
	float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 )
{
	VS_OUTPUT Out = (VS_OUTPUT)0; 
	
	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	
	return Out;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@ӌɂeZ

float4 PS_passTonemap(float2 Tex: TEXCOORD0) : COLOR
{   
	float4 Color, ColorOrg, ShadowColor;
	float2 OblatePos = Tex;
	float dist, distMin, distMax, shadow, Oblateness;

	Color = tex2D( ScnSamp, Tex );
	ColorOrg = Color;

	distMin = 0.5 - scaling * SHADOW_WIDTH + ObjXYZ.x * scaling * SHADOW_WIDTH; //@ÂȂn߂鋗i0.5̉ʒ[j
	distMax = 0.5 + scaling * SHADOW_WIDTH + ObjXYZ.x * scaling * SHADOW_WIDTH; //@ÂȂI鋗i0.5̉ʒ[j

	Oblateness = 1.0 / lerp(AspectRatio, 1.0, ObjXYZ.y); //@ΕʔɌvZ
	OblatePos.y *= Oblateness;
	ShadowColor = float4(ObjRxyz * 57.4647887324, 1);

	dist = distance(OblatePos, float2(0.5, 0.5 * Oblateness)); // ʒ̋
	if(dist > distMax){			//@distMax Ȍ
			Color.rgb = ShadowColor;
	} else if(dist > distMin){	//@distMin  distMax Ԃ̏
		//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
		//	distMini|n߁j distMaxiIjԂ̏
		//
		shadow = (dist - distMin) / (distMax - distMin);
		
		//@eɃg[J[u|邱ƂŃY`lϊ
		shadow = lerp(shadow / TONE_CURVE, shadow, shadow);
		Color.rgb = Color.rgb + (ShadowColor - Color.rgb) * shadow;
	}

	return lerp(ColorOrg, Color, alpha);
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
technique Diffusion <
	string Script = 
		
		"RenderColorTarget0=ScnMap;"
		"RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"ScriptExternal=Color;"
		
		"RenderColorTarget0=;"
		"RenderDepthStencilTarget=;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"Pass=TonemapExec;"
	;
	
> {
	pass TonemapExec < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 VS_passDraw();
		PixelShader  = compile ps_2_0 PS_passTonemap();
	}
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
